# -*- coding: utf-8 -*-
#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#P:/60_PGM/_SRC/xRC_XX_Odkladky.py
"""
Dokumentační komentář modulu.
"""



#Výpis 10.x: Definice třídy počítající své instance
############################################################################
class Cd:
    count = 0;
    def __init__(self):
        Cd.count += 1
        self.id = Cd.count

    def __repr__(self): return '[Moduly.k10.k10_1.demo.Cd_' + self.id + ']'

cda = Cd();



#Výpis 10.4: Definice a použití proměnné
############################################################################
g = 'globální'
import __main__
def f():
    g = 'lokální'
    __main__.g += ' stále'
    return g

f(); g
# 'lokální'
# 'globální stále'


# Výpis 8.11: Třída obsahující vlastní instance jako atributy
############################################################################
class C3:
    """Definice třídy neprojde, protože při definici jejích atributů
       volám konstruktor dříve, než je třída definována.
    """

def __init__(self, id):
    self.id = id

def __repr__(self):
    return "C3[" + id + "]"

ca1 = C3(1)
ca2 = C3(2)
ca3 = C3(3)

class C3:
    """Tato definice je již korektní, instance musím vytvořit dodatečně. """

def __init__(self, id):
    self.id = id

def __repr__(self):
    return "C3[" + id + "]"

ca1 = C3(1)
ca2 = C3(2)
ca3 = C3(3)

C3.ca1, C3.ca2, C3.ca3



#Výpis 7.6:	Ukázky použití externí proměnné
############################################################################
accuracy = 9   #S přesností na 9 platných cifer
def sqrt(x):
    eps = x*10**(-accuracy)
    print('eps=', eps, sep='')
    y = x
    while abs(x - y*y) > eps:
        y = (y + x/y)/2
        print("y=", y)
    return y

sqrt(2); sqrt(4); sqrt(16); sqrt(25), sqrt(1e6)



print('''
# Výpis X.5: Modul M09_01_Cx obsahující definiční a modifikační příkazy z kapitoly 8
############################################################################
#M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M-M
===== START načítání modulu M09_01_Cx #####''')

# Výpis X.1: Definice třídy a jejích atributů
############################################################################
class C0: pass      # Třída s prázdným tělem

class C1:           # Třída definující svůj atribut, metodu a třídu
    ca = 'Atribut třídy C1 - C1.ca'

    def cm():       # Metoda třídy C1 - C1.cm()
        print('Byla zavolána metoda C1.cm')

    class C11:      # Vnitřní třída třídy C1 - C1.C11
        ca = 'Atribut třídy C1.C11 - C1.Cl1.ca'

        def cm():       # Metoda třídy C1 - C1.C11.cm()
            print('Byla zavolána metoda C1.C11.cm')


# Výpis X.2: Práce s atributy objektu
############################################################################
C1.ca = 'Upravený atribut třídy C1 - C1.ca'


# Výpis X.3: Přidávání a mazání atributu objektu
############################################################################
C0.ca = 'Atribut třídy C0 - C0.ca'
C0.cm = lambda: print('Byla zavolána metoda C0.cm')


# Výpis X.4: Třída jako parametr funkce
############################################################################
def method(cls): cls.cm()


# Výpis X.5: Vytvoření prvních instancí
############################################################################
c1a = C1()    # Vytvářím instanci třídy C1


# Výpis X.6: Definice třídy C2
############################################################################
class C2:           # Třída definující svůj atribut, metodu a třídu
    ca = 'Atribut třídy C2'
    count = 0

    def __init__(self):     # Konstruktor instancí třídy C2
        C2.count += 1       # Vytvářím další instanci
        self.ID = C2.count  # Identifikační (rodné) číslo instance
        self.ia = 'Atribut ' + str(self.ID) + '. instance třídy C2'
        print('Vytvořena ', self.ID, '. instance třídy C2', sep='')

    def im(self, x):        # Instanční metoda s jedním parametrem
        print('Metoda instance', self, 's parametrem x =', repr(x))

    def __repr__(this):     # Převod instance na text používaný systémem
        return('<C2_' + str(this.ID) + '>')

    def __str__(moje):      # Převod instance na text používaný funkcí print
        return('«C2_' + str(moje.ID) + '»')


# Výpis X.7: Vytváření instancí třídy C2 a používání jejich atributů
############################################################################
c2a = C2(); c2b = C2(); c2c = C2()


# Výpis X.8: Vytváření nových instančních datových atributů
############################################################################
c2a.ia2 = 'Druhý atribut instance ' + str(c2a)


# Výpis X.9: Změny třídních datových atributů
############################################################################
C2.ca = 'Attr_C2.ca'
c2a.ca = 'Změna'


# Výpis X.10: Zavádění nových třídních funkčních atributů
############################################################################
def im2(self, text):
    print('Druhá metoda instance', self, 's parametrem text =', repr(text))

C2.im2 = im2
del im2

print( '===== KONEC načítání modulu M09_01_Cx #####', '''
#E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E-E
############################################################################''')


print('''
# Výpis 9.6: Import vytvořeného modulu
############################################################################''')
# ================================ RESTART: Shell ================================
import M09_01_Cx as m1
# ===== START zavádění modulu M09_01_Cx #####
# Vytvořena 1. instance třídy C2
# Vytvořena 2. instance třídy C2
# Vytvořena 3. instance třídy C2
# ===== KONEC zavádění modulu M09_01_Cx #####
m1.c1a, m1.c2a, m1.c2c
# (<M09_01_Cx.C1 object at 0x000002A959E6A588>, <C2_1>, <C2_3>)


print('''
# Výpis 9.7: Reimport vytvořeného modulu
############################################################################''')
from importlib import reload
m1r = reload(m1); m1r
# ===== START zavádění modulu M09_01_Cx ##### - Druhý pokus
# Vytvořena 1. instance třídy C2
# Vytvořena 2. instance třídy C2
# Vytvořena 3. instance třídy C2
# ===== KONEC zavádění modulu M09_01_Cx #####
# <module 'M09_01_Cx' from 'Ca:\\#D\\SVN_PGM\\@B_Knihy\\@B_60R_Python_Intro\\60_SVN\\M09_01_Cx.py'>
m1 is m1r
# True
m1r.C0.cm()
# Byla zavolána metoda C0.cm
M09_01_Cx
# Traceback (most recent call last):
#   File "<pyshell#65>", line 1, in <module>
#     M09_01_Cx
# NameError: name 'M09_01_Cx' is not defined


print('\n\n===== KONEC načítání modulu ', __name__, '=====', '''
############################################################################''')


#print('''
#Výpis 0.1: Popisek
############################################################################''')
